/***************************************************************************
 *  Copyright (C) 2009 by Anton R. <commanderkyle@gmail.com>
 *
 *  This file is a part of QAquarelle project.
 *
 *  QAquarelle is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  QAquarelle is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with QAquarelle.  If not, see <http://www.gnu.org/licenses/>.
 */

// Brush feedback procedure.

#version 140


uniform sampler2D mask;
uniform sampler2D patch;
uniform sampler2D color;
uniform float     suckrate;
uniform float     exhaustrate;
uniform vec2      color_txmu;
uniform vec2      color_txadd;

centroid noperspective in vec2 g_texcoord0;
centroid noperspective in vec2 g_texcoord1;

out vec4 result;


void main (void) {
    vec4 ol = texture2D (color, g_texcoord1 * color_txmu + color_txadd);
    vec4 nu = texture2D (patch, g_texcoord0);

    float mi_a = max (0.05, mix (ol.a, nu.a, exhaustrate));
    vec4  mi_c = mix (ol, nu, suckrate);
    vec4  mi_v = ol;

    mi_c.a = mi_a;
    mi_v.a = mi_a;

    // Is there something?
    float colorness = nu.a;

    // If there's no color,
    // mix paint amounts only.
    result = step (0.01, ol.a) *
             mix  (mi_v, mi_c, step (0.01, colorness));
}
