/***************************************************************************
 *  Copyright (C) 2009 by Anton R. <commanderkyle@gmail.com>
 *
 *  This file is a part of QAquarelle project.
 *
 *  QAquarelle is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  QAquarelle is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with QAquarelle.  If not, see <http://www.gnu.org/licenses/>.
 */

// Single texture-to-texture rendering
// with the bump-mapping enabled.

#version 140

uniform sampler2D src;
uniform sampler2D bump;
uniform vec2 bump_off;
uniform vec2 bump_scale;

// A gift to us from a vertex program. ^^'
centroid noperspective in vec4 lightDir;
centroid noperspective in vec2 g_texcoord0;
centroid noperspective in vec2 g_texcoord1;

out vec4 result;


void main (void) {
    vec4 bumpnorm = texture2D (bump, fract (g_texcoord1 * bump_scale + bump_off));
    vec4 color    = texture2D (src,  g_texcoord0);

    float NdotL = max (dot (bumpnorm, lightDir), 0.0);

    result = vec4 (NdotL * color.rgb,
                   color.a);
}
