/***************************************************************************
 *  Copyright (C) 2009 by Anton R. <commanderkyle@gmail.com>
 *
 *  This file is a part of QAquarelle project.
 *
 *  QAquarelle is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  QAquarelle is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with QAquarelle.  If not, see <http://www.gnu.org/licenses/>.
 */

// A simple vertex shader enabling
// the bump-mapping in a fragment shader.

#version 140

// Use low precision.
// precision lowp float;

uniform Transformation {
    mat4 projection_matrix;
    mat4 modelview_matrix;
};

uniform vec3 light_position;
uniform vec3 vertex_normal;

centroid nonperspective in  vec3 vertex;
centroid nonperspective out vec4 lightDir;
centroid nonperspective out vec2 g_texcoord0;
centroid nonperspective out vec2 g_texcoord1;

void main (void) {
    lightDir = normalize (vec4 (1.0, 1.0, 5.0, 0.0));

    gl_Position = projection_matrix * modelview_matrix * vec4 (vertex, 1.0);
    g_texcoord0 = gl_MultiTexCoord0.st;
    g_texcoord1 = gl_MultiTexCoord1.st;
}
